<script lang="ts">
import "intro.js/introjs.css";
import introJs from "intro.js";
export default { name: "HelloWorld",
  props: { msg: String,},
  mounted() { introJs().start();},
  };

import { RouterLink } from 'vue-router';
import { reactive, ref, type Ref } from 'vue'
import { transliterateLatinToPegon, transliteratePegonToLatin, transliterateReversibleLatinToStandardLatin, initIME } from '../transliterator/transliterate'

let ime = initIME()

function inputMethodEdit(text: string) {
  let lastSpaceIndex = text.lastIndexOf(" ") + 1
  let lastWord = text.slice(lastSpaceIndex)
  return text
    .slice(0, lastSpaceIndex)
    .concat(ime.inputEdit(lastWord))
}

let textRight = ref('')
let textRightSub = ref('')
let textLeft = ref('Masukkan Disini')
let textLeftSub = ref('')
let langLeft = ref('Latin')
let langRight = ref('Arab Pegon')
let rightalignRight = ref("text-right")
let rightalignLeft = ref("")

let index = 0;
let languages = ['Indonesia', 'Jawa', 'Sunda', 'Madura'];
let langSelected = ref(languages[0]);
function changeLang(lang: string) {
  langSelected.value = lang;
}

const noFileErrMessage: string = "Tidak ada file"

const fr = new FileReader();

const uploadFile = (e: Event) => {
  const file: File | string = (<HTMLInputElement>e?.target)
    .files?.[0] ?? noFileErrMessage;
  const defaultString: string = ""
  fr.readAsText(file as Blob)
  fr.onloadend = function () {
    const content: string = fr.result as string ?? defaultString
    textLeft.value = content
    usedFunc()
  }
}

// from https://stackoverflow.com/a/64908345
const download = (content: string, mimeType: string, filename: string) => {
  const a = document.createElement('a')
  const blob = new Blob([content], { type: mimeType })
  const url = URL.createObjectURL(blob)
  a.setAttribute('href', url)
  a.setAttribute('download', filename)
  a.click()
}

const clickDownload = (e: Event) => {
  const text = textRight.value
  download(text, "text/plain", "export.txt")
}
let funcLatin = function () {
  // Latin Default
  textRight.value = transliterateLatinToPegon(textLeft.value)
  textLeftSub.value = transliterateReversibleLatinToStandardLatin(textLeft.value)
}

let funcPegon = function () {
  // Pegon Default
  textLeft.value = inputMethodEdit(textLeft.value)
  textRight.value = transliteratePegonToLatin(textLeft.value)
  textRightSub.value = transliterateReversibleLatinToStandardLatin(textRight.value)
}

let usedFunc = funcLatin
let storedFunc = funcPegon

const onInput = (e: Event) => {
  textLeft.value = (<HTMLInputElement>e.target).value
  textRight.value = textLeft.value
  usedFunc()
}

function swapText() {
  [langLeft.value, langRight.value] = [langRight.value, langLeft.value];
  [textLeft.value, textRight.value] = [textRight.value, textLeft.value];
  [rightalignLeft.value, rightalignRight.value] = [rightalignRight.value, rightalignLeft.value];
  [usedFunc, storedFunc] = [storedFunc, usedFunc];
  textRightSub.value = "";
  textLeftSub.value = "";
}
			
</script>

<template>

  <div data-intro="Ahlan wa Sahlan!" class="py-3 text-center animate__animated animate__fadeIn flex flex-col">
    <div class="flex flex-auto justify-center md:justify-start mx-auto px-3 pt-4 pb-0.5 h-12 w-11/12 lg:w-[87.5%]">
      <div class="grid grid-cols-2 basis-[45.5%] lg:basis-1/3">
        <div class="grid relative px-3 py-2 basis-4/5">
          <label data-intro="Tombol disamping 'Bahasa' adalah untuk pilih bahasa yang ingin di-translate" class="h-5 w-48 m-0 justify-start" id="languageLabel">Bahasa {{ langSelected }}</label>
        </div>
        <div class="grid h-7">
          <div class="relative group justify-self-end h-7 text-left">
            <button class="h-8 w-8 pb-2 transition ease-in-out duration-300 hover:scale-125
              rounded-full hover:bg-[#3ED692]"
              id="languageButtonSelector">
              <img alt="Dropdown logo" id="languageSelectImage" src="@/assets/dropdown.svg"
              class="h-7 w-full block group-hover:hidden" fill="currentColor" aria-hidden="true">
              <img alt="Dropdown logo" id="languageSelectImageAlt" src="@/assets/dropdownwhite.svg"
              class="h-7 w-full hidden group-hover:block" fill="currentColor" aria-hidden="true">
            </button>
            <div class="absolute -right-14 top-[8.5] grid-cols-1 py-1 bg-white rounded-md shadow-lg hidden group-hover:block">
              <label class="block px-4 py-2 h-10 w-36 m-0 hover:bg-gray-100 active:border-2"
                v-for="(lang, index) in languages"
                :value="lang"
                v-bind:id="'language'+lang"
                @click="changeLang(lang)">{{ lang }}</label>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="flex flex-col md:flex-row justify-center align-top">
      <div class="mx-3 mt-3 md:basis-2/5">
        <div class="translitname">
          <p id="latin" class="text-base pl-3 align-middle mb-2">{{ langLeft }}</p>
        </div>
        <div class="translit-result-box">
          <div id="left-translit-box" class="translit-result-text-box translitbox">
            <textarea id="translit-textarea" :value="textLeft" @input="onInput" :class="rightalignLeft"
              class="translit-result-text">{{ textLeft }}</textarea>
          </div>
          <div class="translit-result-text-box translit-result-text-box-sub">
            <span class="translit-result-text text-sub">{{ textLeftSub }}</span>
          </div>
        </div>
        <div class="content-start">
          <label for="txt-input">
            <div id="upload-txt-button" class="text-white">Upload TXT</div>
            <input type="file" accept="text/plain" @input="uploadFile" id="txt-input">
          </label>
        </div>
      </div>
      <div class="md:basis-1/8">
        <button @click="swapText" id="swapButton" class="md:mt-7 transition ease-in-out hover:scale-125">
          <img alt="Vue logo" id="swapImage" src="@/assets/arrow.svg" class="swap-button mx-auto" />
        </button>
      </div>
      <div class="mx-3 mt-3 md:basis-2/5">
        <div class="translitname">
          <p id="arab-pegon" class="text-base pl-3 align-middle mb-2">{{ langRight }}</p>
        </div>
        <div class="translit-result-box">
          <div class="translit-result-text-box" id="left-text-box">
            <span class="translit-result-text">{{ textRight }}</span>
          </div>
          <div class="translit-result-text-box translit-result-text-box-sub">
            <span class="translit-result-text text-sub">{{ textRightSub }}</span>
          </div>
        </div>
        <div class="content-start">
          <label for="txt-export">
            <div id="download-txt-button" class="text-white">Export TXT</div>
            <input type="button" @click="clickDownload" id="txt-export">
          </label>
        </div>
      </div>
    </div>
    <div class="border-t text-left bg-white shadow-md px-2 pb-1 explanation">
      <p id="explanation" class="text-base font-normal">
        Halaman ini merupakan halaman untuk melakukan konversi aksara Latin-Pegon ataupun Pegon-Latin. Untuk informasi
        lebih lanjut dapat langsung menuju ke laman <RouterLink to="/docs" class="text-emerald-500">panduan.</RouterLink>
      </p>
    </div>
  </div>
</template>


<style>
input[type=file] {
  position: absolute;
  opacity: 0;
  left: 0;
  right: 0;
  top: 0;
  bottom: 0;
  z-index: 2;
}

#upload-txt-button,
#download-txt-button {
  height: 2rem;
  width: 100%;
  position: relative;
  display: flex;
  align-items: center;
  justify-content: center;
  background: #3ED692;
  z-index: 1;
  @apply mt-3 rounded-full;
}

label[for=txt-input],
label[for=txt-export] {
  position: relative;
  height: 100px;
  width: 10rem !important;
  margin: 0 !important;
}

.translitbox {
  width: 100%;
  height: 20rem;
  background: #FFFFFF;
}

.translit-result-text-box-sub {
  max-height: 50%;
}

#translit-textarea {
  height: 100%;
}

.explanation {
  max-width: 85%;
  @apply mx-auto;
}

#translit-textarea:focus {
  outline: none !important;
}


.translit-result-box {
  width: 100%;
  height: 20rem;
  background: #FFFFFF;
  box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25);
  border-radius: 15px;
  @apply p-3 flex flex-col
}

.translit-result-text-box {
  width: 100%;
  margin: 5px;
  @apply flex flex-col overflow-y-auto
}

.translit-result-text {
  text-align: left;
  background-color: transparent;
  max-height: 100%;
  resize: none;
}

.text-sub {
  opacity: 0.5;
}

.translitname {
  width: 100%;
  height: 2rem;
  background: #FFFFFF;
  box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25);
  border-radius: 15px;
  @apply my-3 items-center flex
}

label {
  position: relative;
  height: 100px;
  width: 200px;
  @apply flex justify-center content-center mx-4;
}
</style>
